<script setup lang="ts">
import { computed, nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Bill } from '@/types/Bill'
import { useBillStore } from '@/stores/Bill'
import { useLoadingStore } from '@/stores/loading'

const billStore = useBillStore()
const tab = ref(0)
const receiptDialog = ref(false)
const paymentDialog1 = ref(false)
const bills = ref<Bill[]>([])
const initialBill: Bill = {
  invoice: 'P',
  date: '',
  namepd: '',
  amountbill: 0,
  units: '',
  priceperunits: 0,
  discount: 0,
  price: 0,
  time: billStore.currentTime.toString(),
  timepay: 'null',
  status: '',
  isChecked: false
}
const editedBill = ref<Bill>(JSON.parse(JSON.stringify(initialBill)))

const headers1 = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Date',
    key: 'date',
    value: 'date'
  },
  {
    title: 'Invoice',
    key: 'invoice',
    value: 'invoice'
  },
  {
    title: 'Name',
    key: 'namepd',
    value: 'namepd'
  },
  {
    title: 'Amount',
    key: 'amountbill',
    value: 'amountbill'
  },
  {
    title: 'Unit',
    key: 'units',
    value: 'units'
  },
  {
    title: 'Price/Unit',
    key: 'priceperunits',
    value: 'priceperunits'
  },
  {
    title: 'Discount',
    key: 'discount',
    value: 'discount'
  },
  {
    title: 'Price',
    key: 'price',
    value: 'price'
  },
  {
    title: 'Time',
    key: 'time',
    value: 'time'
  },
  {
    title: 'Time-Pay',
    key: 'timepay',
    value: 'timepay'
  },
  {
    title: 'Status',
    key: 'status',
    value: 'status'
  },

  { title: 'Actions', key: 'actions', sortable: false }
]

const headers2 = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Date',
    key: 'date',
    value: 'date'
  },
  {
    title: 'Invoice',
    key: 'invoice',
    value: 'invoice'
  },
  {
    title: 'Name',
    key: 'namepd',
    value: 'namepd'
  },
  {
    title: 'Amount',
    key: 'amountbill',
    value: 'amountbill'
  },
  {
    title: 'Price',
    key: 'price',
    value: 'price'
  },
  {
    title: 'Time',
    key: 'time',
    value: 'time'
  },
  {
    title: 'Status',
    key: 'status',
    value: 'status'
  },

  { title: 'Actions', key: 'actions', sortable: false }
]

const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog1 = ref(false)
const dialog2 = ref(false)
const dialogDelete1 = ref(false)
const dialogDelete2 = ref(false)
const loading = ref(false)
const receiptDialogNotpay = ref(false)
const loadingStore = useLoadingStore()

let editedIndex = -1
let lastId = 4

const isPaid = (item: Bill) => {
  return item.timepay !== 'null'
}
const calculatedPrice = computed(() => {
  const { amountbill, priceperunits, discount } = billStore.editedBill
  return amountbill * priceperunits - discount
})

function onSubmit() {
  // Implement if needed
}

function closeDelete() {
  dialogDelete1.value = false
  nextTick(() => {
    billStore.clearForm()
  })
}

async function deleteItemConfirm() {
  // Delete item from list
  await billStore.deleteBill()
  closeDelete()
}
async function editItem(item: Bill) {
  if (!item.id) return
  await billStore.getBill(item.id)
  dialog1.value = true
}
async function deleteItem(item: Bill) {
  if (!item.id) return
  await billStore.getBill(item.id)
  dialogDelete1.value = true
  editedIndex = -1
}
function closeDialog() {
  dialog1.value = false
  nextTick(() => {
    billStore.clearForm()
  })
}

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return

  const currentTime = billStore.getCurrentTime()

  editedBill.value.time = currentTime

  await billStore.saveBill()
  closeDialog()
}

const isAnyBillChecked = computed(() => {
  return billStore.bills.some((bill) => bill.isChecked)
})

const selectedBills = computed(() => {
  return billStore.bills.filter((bill) => bill.isChecked)
})

async function printBill() {
  const selectedData = selectedBills.value
  editedBill.value = selectedData[0]
  receiptDialog.value = true
}

onMounted(() => {
  billStore.getBills()
})
</script>

<template>
  <div>
    <v-tabs v-model="tab" color="#FFA500" align-tabs="center" style="background-color: #aaa">
      <v-tab style="color: white; font-size: 18pt" :value="1" color="black"
        ><v-icon>mdi-invoice-text-multiple</v-icon></v-tab
      >
      <!-- <v-tab style="color: white; font-size: 18pt" :value="2" color="black"><v-icon>mdi-information</v-icon></v-tab> -->
    </v-tabs>
    <v-window v-model="tab">
      <v-window-item :value="1">
        <v-toolbar flat>
          <v-toolbar-title>Bills General</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <v-dialog v-model="dialog1" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" :disabled="!isAnyBillChecked" @click="printBill()"
                ><v-icon>mdi-printer</v-icon></v-btn
              >
              <v-btn color="primary" v-bind="props"> New Bill </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Bill</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="billStore.editedBill.date"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Date"
                          type="date"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="billStore.editedBill.invoice"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Invoice"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="billStore.editedBill.namepd"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="billStore.editedBill.amountbill"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Amount"
                          type="number"
                          inputmode="numeric"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="billStore.editedBill.units"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Unit"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="billStore.editedBill.priceperunits"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Price/Unit"
                          type="number"
                          inputmode="numeric"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="billStore.editedBill.discount"
                          :readonly="loading"
                          clearable
                          label="Discount"
                          type="number"
                          inputmode="numeric"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-text-field
                          v-model="calculatedPrice"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Price"
                          type="number"
                          inputmode="numeric"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-text-field
                          v-model="billStore.currentTime"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Time"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <v-dialog v-model="receiptDialog" max-width="1200px" persistent>
            <v-card class="dialog-card">
              <v-card-title class="text-h5">Bill Receipt</v-card-title>
              <v-card-text>
                <v-table>
                  <thead>
                    <tr>
                      <th class="text-left">Id</th>
                      <th class="text-left">Invoice</th>
                      <th class="text-left">Name</th>
                      <th class="text-left">Amount</th>
                      <th class="text-left">Unit</th>
                      <th class="text-left">Price/Unit</th>
                      <th class="text-left">Discount</th>
                      <th class="text-left">Price</th>
                      <th class="text-left">Time</th>
                      <th class="text-left">Time-Pay</th>
                      <th class="text-left">Status</th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr v-for="item in selectedBills" :key="item.id">
                      <td>{{ item.id }}</td>
                      <td>{{ item.invoice }}</td>
                      <td>{{ item.namepd }}</td>
                      <td>{{ item.amountbill }}</td>
                      <td>{{ item.units }}</td>
                      <td>{{ item.priceperunits }}</td>
                      <td>{{ item.discount }}</td>
                      <td>{{ item.price }}</td>
                      <td>{{ item.time }}</td>
                      <td>{{ item.timepay }}</td>
                      <td>{{ item.status }}</td>
                    </tr>
                  </tbody>
                </v-table>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue darken-1" @click="receiptDialog = false">Close</v-btn>
                <v-btn color="blue darken-1" @click="receiptDialog = false">Print</v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete1" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
        <v-data-table :headers="headers1" :items="billStore.bills">
          <template v-slot:[`item.actions`]="{ item }">
            <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
            <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
            <span class="me-2"></span>
            <span class="me-2"></span>
            <v-icon size="small" class="me-2" :class="{ 'disabled-checkbox': !isPaid(item) }">
              <input type="checkbox" v-model="item.isChecked" @click.stop />
            </v-icon>
          </template>
          <template v-slot:item.status="{ item }">
            <v-btn color="green" @click="billStore.pay(item)" :disabled="isPaid(item)">
              <v-icon left>mdi-currency-usd</v-icon>
            </v-btn>
            <v-dialog v-model="billStore.paymentDialog1" max-width="500px" persistent>
              <v-card>
                <v-card-title class="text-h5">Payment Status</v-card-title>
                <v-card-text> You have paid successfully. </v-card-text>
                <v-card-actions class="text-right justify-end">
                  <v-btn color="blue darken-1" @click="billStore.handleClosePaymentDialog"
                    >Close</v-btn
                  >
                </v-card-actions>
              </v-card>
            </v-dialog>
            <span class="me-2"></span>
            <span class="me-2"></span>
            <v-btn color="red" @click="billStore.cancelPayment(item)" :disabled="!isPaid(item)">
              <v-icon left>mdi-cancel</v-icon>
            </v-btn>
            <v-dialog v-model="billStore.paymentDialog2" max-width="500px" persistent>
              <v-card>
                <v-card-title class="text-h5">Payment Status</v-card-title>
                <v-card-text> Cancel Payment. </v-card-text>
                <v-card-actions class="text-right justify-end">
                  <v-btn color="blue darken-1" @click="billStore.handleClosePaymentDialog"
                    >Close</v-btn
                  >
                </v-card-actions>
              </v-card>
            </v-dialog>
          </template>
          <template v-slot:item.timepay="{ item }">
            {{ item.timepay }}
          </template>
          <template v-slot:no-data>
            <v-btn color="primary" @click="billStore.getBills()"> Reset </v-btn>
          </template>
        </v-data-table>
      </v-window-item>

      <v-window-item :value="2">
        <v-toolbar flat>
          <v-toolbar-title>Bills Stock</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <v-dialog v-model="dialog2" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" v-bind="props"> New Bill </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5"> Bill</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="billStore.editedBill.invoice"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Invoice"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="billStore.editedBill.namepd"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="billStore.editedBill.amountbill"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Amount"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-text-field
                          v-model="billStore.editedBill.price"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Price"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-text-field
                          v-model="billStore.editedBill.time"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Time"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete2" max-width="500px">
            <v-card>
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
        <v-data-table :headers="headers2" :items="bills">
          <template v-slot:[`item.actions`]="{ item }">
            <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
            <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
          </template>
          <template v-slot:no-data>
            <v-btn color="primary" @click="billStore.getBills()"> Reset </v-btn>
          </template>
        </v-data-table>
      </v-window-item>
    </v-window>
  </div>
</template>

<style>
.icon {
  font-size: 12px;
}
.disabled-checkbox {
  opacity: 0.5;
  pointer-events: none;
}
.dialog-card {
  width: 100%;
}
</style>
